#include "guimodule.h"

GuiModule::~GuiModule()
{
	// override this when necessary
}

void GuiModule::finalize()
{
	// override this when necessary
}

QWidget *GuiModule::isParent()
{
	return 0;
}

void GuiModule::setMID(long newmid)
{
	_MID = newmid;
}

long GuiModule::MID()
{
	return _MID;
}

void *GuiModule::get_MS()
{
    static ModuleServer<GuiModule> *MS = 0;

    if(!MS) MS = new ModuleServer<GuiModule>;
    return(MS);
}

void GuiModule::assignReceiver(long portid, Arts::Receiver *receiver)
{
	pair<long,Arts::Receiver *> p(portid,Arts::Receiver::_duplicate(receiver));
	receivers.push_back(p);
}

void GuiModule::emitSignal(long portid, float value)
{
	list<pair<long,Arts::Receiver *> >::iterator ri;

	for(ri=receivers.begin();ri != receivers.end();ri++)
	{
		pair<long,Arts::Receiver *> p = *ri;
		if(p.first == portid)
			p.second->newFloatValue(value);
	}
}

void GuiModule::addPort(Arts::ModuleInfo &info, const char *name,
     Arts::PortDirection dir, Arts::PortDataType datatype,
     Arts::PortConnType conntype)
{
	unsigned long len;

	len = info.ports.length();
	info.ports.length(len+1);

	info.ports[len].Direction = dir;
	info.ports[len].DataType = datatype;
	info.ports[len].ConnType = conntype;

	len = info.portnames.length();
	info.portnames.length(len+1);
	info.portnames[len] = CORBA::string_dup(name);
}

float GuiModule::getFloatParam(Arts::ModuleDesc *desc, const char *name)
{
	Arts::PortDesc_var pd = desc->findPort(name);

	if(pd && pd->hasValue()) return(pd->FloatValue());
	printf("port %s has no value\n",name);
	return(0.0);
}

string GuiModule::getStringParam(Arts::ModuleDesc *desc, const char *name)
{
	Arts::PortDesc_var pd = desc->findPort(name);
	
	if(pd && pd->hasValue()) return(string(pd->StringValue()));
	return(string(""));
}

long GuiModule::lookupPort(Arts::ModuleDesc *desc, const char *name)
{
	Arts::PortDesc_var pd = desc->findPort(name);
	
	if(pd) return(pd->ID());
	return(0);
}
