#ifndef _GUIMODULE_H
#define _GUIMODULE_H

#include "synth.h"
#include "../synthesizer/moduleserver.h"
#include "qwidget.h"
#include "qlayout.h"
#include <utility>
#include <list>

class GuiModule : public ModuleServerModule
{
protected:
	long _MID;
	list<pair<long,Arts::Receiver *> > receivers;
public:
	virtual void publish(Arts::ArtsServer *Server,Arts::ModuleBroker *Broker)=0;
	virtual void applyParameters(Arts::ModuleDesc *desc) = 0;
	virtual void start() = 0;
	virtual void setParent(QWidget *widget, QBoxLayout *layout) = 0;
	virtual ~GuiModule();

	// if this returns a widget, this module can be parent widget for other
	// modules
	virtual QWidget *isParent();

	virtual void finalize();

	long GuiModule::MID();
	void GuiModule::setMID(long newmid);

	void addPort(Arts::ModuleInfo &info, const char *name,
    	 Arts::PortDirection dir, Arts::PortDataType datatype,
     	 Arts::PortConnType conntype);

	void assignReceiver(long portid, Arts::Receiver *receiver);
	void emitSignal(long portid, float value);
	float getFloatParam(Arts::ModuleDesc *desc, const char *name);
	string getStringParam(Arts::ModuleDesc *desc, const char *name);
	long lookupPort(Arts::ModuleDesc *desc, const char *name);
	Arts::PortDesc *findPortParam(Arts::PortDescSeq *pds, const char *name,
										Arts::PortDataType dt);
//--- module server support ---
	static void *get_MS();
};

#endif
