#ifndef __EXTPORT_H__
#define __EXTPORT_H__
#include "scomponent.h"
#include "synth.h"
#include "module.h"

class StructurePort :public StructureComponent {
protected:
	Arts::StructurePortDesc_var SPortDesc;
	Arts::StructureDesc_var StructureDesc;
	ModulePort *_port;
	bool _selected, _visible;
	int _x,_y;
public:
	StructurePort(Arts::StructurePortDesc *SPortDesc,
    			Arts::StructureDesc *StructureDesc, StructureCanvas *canvas);
	~StructurePort();

	//--

	void raisePosition();
	void lowerPosition();
	void rename(const char *newname);
	long id();
	long position();
	ModulePort *port();

	// Component Interface
	ComponentType type();

	ModulePort *portAt(int segment, int x, int y);
	void dumpPorts(list<ModulePort *>& ports);

	bool visible();
	void show();
	void hide();

	bool drawNeedsBackground(int segment);
	void drawSegment(QPainter *dest, int cellsize, int segment);
	QPixmap *pixmap();
	const char *name();

	bool selected();
	void setSelected(bool newselection);

	// in cells
	bool move(int x, int y);
	int width();
	int height();
	int x();
	int y();
};
#endif
