#include "execrequest.h"

ExecRequest::ExecRequest(Arts::ArtsServer *Server, long StructureID)
{
	this->Server = Arts::ArtsServer::_duplicate(Server);
	mid = Server->createModules();
	_ServerID = Server->ID();
	_StructureID = StructureID;
}

long ExecRequest::ServerID()
{
	return _ServerID;
}

long ExecRequest::StructureID()
{
	return _StructureID;
}

long ExecRequest::MID()
{
	return mid;
}

const Arts::ModuleDescSeq& ExecRequest::Modules()
{
	return _Modules;
}

// FIXME: eventually implement releaseModules which releases the modules
// sequence as soon as it is no longer needed in the creation process

bool ExecRequest::createModule(Arts::ModuleDesc *desc)
{
	unsigned long l = _Modules.length();
	_Modules.length(l+1);
	_Modules[l] = Arts::ModuleDesc::_duplicate(desc);

	return(Server->createModule(mid, desc));
}

bool ExecRequest::localConnectModules()
{
	return(Server->localConnectModules(mid));
}

bool ExecRequest::remoteConnectModules(ExecRequest *remote)
{
	return(Server->remoteConnectModules(mid,remote->mid,remote->Modules(),remote->Server));
}

bool ExecRequest::finalizeModules()
{
	return(Server->finalizeModules(mid));
}

void ExecRequest::startModules()
{
	Server->startModules(mid);
}

void ExecRequest::deleteModules()
{
	Server->deleteModules(mid);
}
