#ifndef __MBROKER_IMPL_H__
#define __MBROKER_IMPL_H__

#include "synth.h"
#include "artsobject.h"

class MB_ServerEntry {
public:
	Arts::ModuleInfo *info;
	Arts::ArtsServer_var server;

	MB_ServerEntry(Arts::ArtsServer *server, Arts::ModuleInfo *info);
};

// Implementation for interface ModuleBroker
class ModuleBroker_impl : 
  virtual public ArtsObject_impl,
  virtual public Arts::ModuleBroker_skel
{
  protected:
	list<MB_ServerEntry *> infolist;
	CORBA::Long nextID;
	CORBA::Long _updateCount;

  public:
    Arts::StringSeq* publishedModules();
	CORBA::Long updateCount();

    void publishModule(Arts::ArtsServer *server, const Arts::ModuleInfo& info);
    Arts::ModuleInfo* lookupModule(const char* name);
    void removeModule(Arts::ArtsServer *server, const char* name);
    void serverShutdown(Arts::ArtsServer *server);
	Arts::ArtsServerSeq* whichServerProvides(const char *name);
	CORBA::Long mkID();

	ModuleBroker_impl();
};


#endif
